"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _debug = _interopRequireDefault(require("debug"));

var _lodash = _interopRequireDefault(require("lodash.escaperegexp"));

var _winPath = _interopRequireDefault(require("./winPath"));

var _constants = require("./constants");

var _registerBabel2 = _interopRequireDefault(require("./registerBabel"));

// 参考：
// https://github.com/vuejs/vue-cli/blob/next/packages/%40vue/cli-service/lib/PluginAPI.js
var PluginAPI =
/*#__PURE__*/
function () {
  function PluginAPI(id, service) {
    (0, _classCallCheck2.default)(this, PluginAPI);
    this.id = id;
    this.service = service;
    this.utils = {
      winPath: _winPath.default,
      debug: (0, _debug.default)("umi-plugin: ".concat(id))
    };
    this.placeholder = {
      IMPORT: _constants.PLACEHOLDER_IMPORT,
      RENDER: _constants.PLACEHOLDER_RENDER
    };
  }

  (0, _createClass2.default)(PluginAPI, [{
    key: "register",
    value: function register(key, fn) {
      if (!this.service.pluginMethods[key]) {
        this.service.pluginMethods[key] = [];
      }

      this.service.pluginMethods[key].push({
        fn: fn
      });
    }
  }, {
    key: "modifyWebpackConfig",
    value: function modifyWebpackConfig(fn) {
      this.register('modifyWebpackConfig', fn);
    }
  }, {
    key: "registerBabel",
    value: function registerBabel(files) {
      var excapedFiles = files.map(function (file) {
        return (0, _lodash.default)(file);
      });
      (0, _registerBabel2.default)(this.service.babel, {
        only: [new RegExp("(".concat(excapedFiles.join('|'), ")"))]
      });
    }
  }]);
  return PluginAPI;
}();

var _default = PluginAPI;
exports.default = _default;