"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _keys = _interopRequireDefault(require("@babel/runtime/core-js/object/keys"));

var _assert = _interopRequireDefault(require("assert"));

var _isPlainObject = _interopRequireDefault(require("is-plain-object"));

var _path = require("path");

var _fs = require("fs");

function _default(api) {
  var cwd = api.service.paths.cwd;

  function getFiles(pages) {
    var files = [(0, _path.join)(__dirname, '../../../template/document.ejs'), (0, _path.join)(cwd, 'src/page/document.ejs'), (0, _path.join)(cwd, 'src/pages/document.ejs'), (0, _path.join)(cwd, 'pages/document.ejs')];

    if (pages) {
      (0, _keys.default)(pages).forEach(function (key) {
        var document = pages[key].document;

        if (document) {
          files.push((0, _path.join)(cwd, document));
        }
      });
    }

    return files;
  }

  return {
    name: 'pages',
    validate: function validate(pages) {
      (0, _assert.default)((0, _isPlainObject.default)(pages), "\"".concat(api.relativeFile, "\" \u7684 \"pages\" \u914D\u7F6E\u5FC5\u987B\u662F \"Object \u5BF9\u8C61\"\uFF0C\u4F46\u4F60\u914D\u7F6E\u7684\u662F ").concat(pages.toString(), " \u3002"));
      (0, _keys.default)(pages).forEach(function (key) {
        var document = pages[key].document;

        if (document) {
          (0, _assert.default)((0, _fs.existsSync)((0, _path.join)(cwd, document)), "\"".concat(api.relativeFile, "\" \u6587\u4EF6\u4E2D \"").concat(key, "\" \u7684\u6A21\u677F\u6587\u4EF6 \"").concat(document, "\" \u5E76\u4E0D\u5B58\u5728\u3002"));
        }
      });
    },
    watch: function watch(pages) {
      if (!pages) {
        pages = api.config[this.name];
      }

      api.unwatch();
      var files = getFiles(pages);
      api.watch(files).on('all', function (type) {
        if (type === 'add') return;
        api.service.reload();
      });
    },
    onChange: function onChange(newPages) {
      api.service.reload();
      this.watch(newPages);
    }
  };
}