"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.watch = watch;
exports.unwatch = unwatch;

var _keys = _interopRequireDefault(require("@babel/runtime/core-js/object/keys"));

var _chokidar = _interopRequireDefault(require("chokidar"));

// 按 key 存，值为数组
var watchers = {};

function watch(key, files) {
  if (!watchers[key]) {
    watchers[key] = [];
  }

  var watcher = _chokidar.default.watch(files, {
    ignoreInitial: true
  });

  watchers[key].push(watcher);
  return watcher;
}

function unwatch(key) {
  if (!key) {
    return (0, _keys.default)(watchers).forEach(unwatch);
  }

  if (watchers[key]) {
    watchers[key].forEach(function (watcher) {
      watcher.close();
    });
  }
}