"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _path = require("path");

var _fs = require("fs");

function test(path) {
  return (0, _fs.existsSync)(path) && (0, _fs.statSync)(path).isDirectory();
}

function template(path) {
  return (0, _path.join)(__dirname, '../template', path);
}

function _default(service) {
  var cwd = service.cwd,
      tmpDirectory = service.tmpDirectory,
      outputPath = service.outputPath,
      libraryName = service.libraryName;
  var pagesPath = 'pages';

  if (process.env.PAGES_PATH) {
    pagesPath = process.env.PAGES_PATH;
  }

  if (test((0, _path.join)(cwd, 'src/page'))) {
    pagesPath = 'src/page';
  }

  if (test((0, _path.join)(cwd, 'src/pages'))) {
    pagesPath = 'src/pages';
  }

  var absPagesPath = (0, _path.join)(cwd, pagesPath);
  var absSrcPath = (0, _path.join)(absPagesPath, '../');
  var envAffix = process.env.NODE_ENV === 'development' ? '' : "-production";
  var tmpDirPath = "".concat(pagesPath, "/").concat(tmpDirectory).concat(envAffix);
  var absTmpDirPath = (0, _path.join)(cwd, tmpDirPath);
  return {
    cwd: cwd,
    outputPath: outputPath,
    absOutputPath: (0, _path.join)(cwd, outputPath),
    pagesPath: pagesPath,
    absPagesPath: absPagesPath,
    absSrcPath: absSrcPath,
    tmpDirPath: tmpDirPath,
    absTmpDirPath: absTmpDirPath,
    absRouterJSPath: (0, _path.join)(absTmpDirPath, 'router.js'),
    absLibraryJSPath: (0, _path.join)(absTmpDirPath, "".concat(libraryName, ".js")),
    absRegisterSWJSPath: (0, _path.join)(absTmpDirPath, 'registerServiceWorker.js'),
    absPageDocumentPath: (0, _path.join)(absPagesPath, 'document.ejs'),
    defaultEntryTplPath: template('entry.js.tpl'),
    defaultRouterTplPath: template('router.js.tpl'),
    defaultRegisterSWTplPath: template('registerServiceWorker.js'),
    defaultDocumentPath: template('document.ejs')
  };
}