"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _lodash = _interopRequireDefault(require("lodash.escaperegexp"));

var _resolve = _interopRequireDefault(require("resolve"));

var _registerBabel = _interopRequireDefault(require("./registerBabel"));

function _default() {
  var opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var _opts$configPlugins = opts.configPlugins,
      configPlugins = _opts$configPlugins === void 0 ? [] : _opts$configPlugins,
      _opts$pluginsFromOpts = opts.pluginsFromOpts,
      pluginsFromOpts = _opts$pluginsFromOpts === void 0 ? [] : _opts$pluginsFromOpts,
      babel = opts.babel,
      cwd = opts.cwd;

  function pluginToPath(plugins) {
    return plugins.map(function (p) {
      try {
        return _resolve.default.sync(p, {
          basedir: cwd
        });
      } catch (e) {
        throw new Error("Plugin ".concat(p, " don't exists."));
      }
    });
  } // 拿到绝对路径


  var pluginPaths = [].concat((0, _toConsumableArray2.default)(pluginToPath(configPlugins)), (0, _toConsumableArray2.default)(pluginToPath(pluginsFromOpts))); // 用户给的插件需要做 babel 转换

  if (pluginPaths.length) {
    (0, _registerBabel.default)(babel, {
      only: [new RegExp("(".concat(pluginPaths.map(function (p) {
        return (0, _lodash.default)(p);
      }).join('|'), ")"))]
    });
  } // 内置插件


  var builtInPlugins = ['./plugins/global-css', './plugins/layout', './plugins/fastclick', './plugins/hd', './plugins/mock'];
  var plugins = [].concat((0, _toConsumableArray2.default)(builtInPlugins.map(function (p) {
    var apply = require(p); // eslint-disable-line


    return {
      id: p.replace(/^.\//, 'built-in:'),
      apply: apply.default || apply
    };
  })), (0, _toConsumableArray2.default)(pluginPaths.map(function (p) {
    var apply = require(p); // eslint-disable-line


    return {
      id: p.replace(cwd, 'user:'),
      apply: apply.default || apply
    };
  })));
  return plugins;
}