"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _keys = _interopRequireDefault(require("@babel/runtime/core-js/object/keys"));

var _stringify = _interopRequireDefault(require("@babel/runtime/core-js/json/stringify"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _path = require("path");

var _fs = require("fs");

var _chalk = _interopRequireDefault(require("chalk"));

var _assert = _interopRequireDefault(require("assert"));

var _bodyParser = _interopRequireDefault(require("body-parser"));

var HttpMock =
/*#__PURE__*/
function () {
  function HttpMock(_ref) {
    var cwd = _ref.cwd,
        devServer = _ref.devServer,
        api = _ref.api;
    (0, _classCallCheck2.default)(this, HttpMock);
    this.devServer = devServer;
    this.api = api;
    this.absMockPath = (0, _path.join)(cwd, 'mock');
    this.configPath = (0, _path.join)(cwd, '.umirc.mock.js');
    this.applyMock();
  }

  (0, _createClass2.default)(HttpMock, [{
    key: "applyMock",
    value: function applyMock() {
      try {
        this.realApplyMock();
      } catch (e) {
        console.error(_chalk.default.red("mock failed: ".concat(e.message)));
      }
    }
  }, {
    key: "realApplyMock",
    value: function realApplyMock() {
      var _this = this;

      var config = this.getConfig();
      this.api.debug("config: ".concat((0, _stringify.default)(config)));
      var devServer = this.devServer;
      var app = devServer.app;
      devServer.use(_bodyParser.default.json({
        limit: '5mb',
        strict: false
      }));
      devServer.use(_bodyParser.default.urlencoded({
        extended: true,
        limit: '5mb'
      }));
      (0, _keys.default)(config).forEach(function (key) {
        var keyParsed = _this.parseKey(key);

        (0, _assert.default)(!!app[keyParsed.method], "method of ".concat(key, " is not valid"));
        (0, _assert.default)(typeof config[key] === 'function' || typeof config[key] === 'object', "mock value of ".concat(key, " should be function or object, but got ").concat(typeof config[key]));
        app[keyParsed.method](keyParsed.path, _this.createMockHandler(keyParsed.method, keyParsed.path, config[key]));
      }); // 调整 stack，把 historyApiFallback 放到最后

      var lastIndex = null;

      app._router.stack.forEach(function (item, index) {
        if (item.name === 'webpackDevMiddleware') {
          lastIndex = index;
        }
      }); // const mockAPILength = app._router.stack.length - 1 - lastIndex;


      if (lastIndex && lastIndex > 0) {
        var newStack = app._router.stack;
        newStack.push(newStack[lastIndex - 1]);
        newStack.push(newStack[lastIndex]);
        newStack.splice(lastIndex - 1, 2);
        app._router.stack = newStack;
      }
    }
  }, {
    key: "createMockHandler",
    value: function createMockHandler(method, path, value) {
      return function mockHandler() {
        var res = arguments.length <= 1 ? undefined : arguments[1];

        if (typeof value === 'function') {
          value.apply(void 0, arguments);
        } else {
          res.json(value);
        }
      };
    }
  }, {
    key: "parseKey",
    value: function parseKey(key) {
      var method = 'get';
      var path = key;

      if (key.indexOf(' ') > -1) {
        var splited = key.split(' ');
        method = splited[0].toLowerCase();
        path = splited[1];
      }

      return {
        method: method,
        path: path
      };
    }
  }, {
    key: "getConfig",
    value: function getConfig() {
      if ((0, _fs.existsSync)(this.configPath)) {
        this.api.registerBabel([this.configPath, this.absMockPath]);
        return require(this.configPath); // eslint-disable-line
      } else {
        return {};
      }
    }
  }]);
  return HttpMock;
}();

var _default = HttpMock;
exports.default = _default;