"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setRequest = setRequest;
exports.getRequest = getRequest;

var _assert = _interopRequireDefault(require("assert"));

var debug = require('debug')('umi-build-dev:requestCache'); // Urls user requested


var requested = {};

function setRequest(url) {
  var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  (0, _assert.default)(typeof url === 'string', "request url must be string, but got ".concat(url));
  debug("request: ".concat(url));
  var onChange = opts.onChange;

  if (!requested[url]) {
    requested[url] = 1;
    if (url === '/index.html') requested['/'] = 1;
    if (onChange) onChange();
  }
}

function getRequest() {
  return requested;
}